Option Strict Off
Option Explicit On
Module CSP2

    Public Enum CommPorts
        COM1 = 0
        COM2 = 1
        COM3 = 2
        COM4 = 3
        COM5 = 4
        COM6 = 5
        COM7 = 6
        COM8 = 7
        COM9 = 8
        COM10 = 9
        COM11 = 10
        COM12 = 11
        COM13 = 12
        COM14 = 13
        COM15 = 14
        COM16 = 15
    End Enum

	'// Communications
	Declare Function csp2Init Lib "csp2.dll" (ByVal nComPort As Integer) As Integer
	Declare Function csp2Restore Lib "csp2.dll" () As Integer
	Declare Function csp2WakeUp Lib "csp2.dll" () As Integer
	Declare Function csp2DataAvailable Lib "csp2.dll" () As Integer
	
	'// Basic Functions
	Declare Function csp2ReadData Lib "csp2.dll" () As Integer
	Declare Function csp2ClearData Lib "csp2.dll" () As Integer
	Declare Function csp2PowerDown Lib "csp2.dll" () As Integer
	Declare Function csp2GetTime Lib "csp2.dll" (ByRef aTimeBuf As Byte) As Integer
	Declare Function csp2SetTime Lib "csp2.dll" (ByRef aTimeBuf As Byte) As Integer
	Declare Function csp2SetDefaults Lib "csp2.dll" () As Integer
	
	'// CSP Data Get
	Declare Function csp2GetPacket Lib "csp2.dll" (ByRef stPacketData As Byte, ByVal lgBarcodeNumber As Integer, ByVal maxLength As Integer) As Integer
	Declare Function csp2GetDeviceId Lib "csp2.dll" (ByRef szDeviceId As Byte, ByVal nMaxLength As Integer) As Integer
	Declare Function csp2GetProtocol Lib "csp2.dll" () As Integer
	Declare Function csp2GetSystemStatus Lib "csp2.dll" () As Integer
	Declare Function csp2GetSwVersion Lib "csp2.dll" (ByVal szSwVersion As String, ByVal nMaxLength As Integer) As Integer
	Declare Function csp2GetASCIIMode Lib "csp2.dll" () As Integer
	Declare Function csp2GetRTCMode Lib "csp2.dll" () As Integer
	
	'// DLL Configuration
	Declare Function csp2SetRetryCount Lib "csp2.dll" (ByVal nRetryCount As Integer) As Integer
	Declare Function csp2GetRetryCount Lib "csp2.dll" () As Integer
	
	'// Miscellaneous
	Declare Function csp2GetDllVersion Lib "csp2.dll" (ByVal szDllVersion As String, ByVal nMaxLength As Integer) As Integer
	Declare Function csp2TimeStamp2Str Lib "csp2.dll" (ByRef Stamp As Byte, ByVal value As String, ByVal nMaxLength As Integer) As Integer
	Declare Function csp2GetCodeType Lib "csp2.dll" (ByVal CodeID As Integer, ByVal CodeType As String, ByVal nMaxLength As Integer) As Integer
	
	'// Advanced functions
	Declare Function csp2ReadRawData Lib "csp2.dll" (ByRef aBuffer As Byte, ByVal nMaxLength As Integer) As Integer
	Declare Function csp2SetParam Lib "csp2.dll" (ByVal nParam As Integer, ByRef szString As Byte, ByVal nMaxLength As Integer) As Integer
	Declare Function csp2GetParam Lib "csp2.dll" (ByVal nParam As Integer, ByRef szString As Byte, ByVal nMaxLength As Integer) As Integer
	Declare Function csp2Interrogate Lib "csp2.dll" () As Integer
	Declare Function csp2GetCTS Lib "csp2.dll" () As Integer
	Declare Function csp2SetDTR Lib "csp2.dll" (ByVal nOnOff As Integer) As Integer
	Declare Function csp2SetDebugMode Lib "csp2.dll" (ByVal nOnOff As Integer) As Integer
	
	'// Returned status values...
	Public Const STATUS_OK As Integer = 0
	Public Const COMMUNICATIONS_ERROR As Integer = -1
	Public Const BAD_PARAM As Integer = -2
	Public Const SETUP_ERROR As Integer = -3
	Public Const INVALID_COMMAND_NUMBER As Integer = -4
	Public Const COMMAND_LRC_ERROR As Integer = -7
	Public Const RECEIVED_CHARACTER_ERROR As Integer = -8
	Public Const GENERAL_ERROR As Integer = -9
	Public Const FILE_NOT_FOUND As Integer = 2
	Public Const ACCESS_DENIED As Integer = 5
	
	'// Parameter values...
	Public Const PARAM_OFF As Integer = 0
	Public Const PARAM_ON As Integer = 1
	
	Public Const DATA_AVAILABLE As Integer = 1
	Public Const DATA_NOT_AVAILABLE As Integer = 0
	
	Public Const DETERMINE_SIZE As Integer = 0
End Module