﻿Option Strict Off
Option Explicit On

Imports VB = Microsoft.VisualBasic

Public Class MainForm
    Private bComConnected As Boolean

    Private Sub MainForm_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Try

            Dim nRetVal As Object
            ' Declare the string for the dll version
            Dim bstrDllVersion As New Compatibility.VB6.FixedLengthString(30)

            'Start dll logging...
            csp2SetDebugMode(1)

            'Set the COM connected to false and update the
            'controls on the mainform
            bComConnected = False

            'Get the dll version
            nRetVal = csp2GetDllVersion(bstrDllVersion.Value, Len(bstrDllVersion.Value))

            'Open Port
            OpenCom()

            'Read Bar Codes
            ReadBarCode()
        Catch ex As System.Exception
            'Add your error handling code here.
            'Display error message, if any.
            System.Windows.Forms.MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub MainForm_Closed(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Closed
        Call csp2Restore()
    End Sub

    Private Sub OpenCom()
        Dim dwRC As Integer
        Dim dwComPort As Integer

        'Open the com port
        dwComPort = txtComPort.Text - 1

        dwRC = csp2Init(dwComPort)

        If dwRC <> STATUS_OK Then
            DisplayInBCWindow("No se pudo abrir el puerto COM" & CStr(dwComPort + 1))
        Else

            DisplayInBCWindow("COM" & CStr(dwComPort + 1) & " Abierto")

            'Disable COM Select
            bComConnected = True
        End If
    End Sub

    Public Sub ReadBarCode()
        Me.txtCodes.Text = ""

        Dim nRC As Integer
        Dim nNumOfBarcodes As Integer
        Dim i As Integer
        Dim j As Integer

        Dim arrbyteBarcode(99) As Byte '100 elements
        Dim nBytesRead As Integer
        Dim bstrBarcode As String
        Dim bstrTmp As New Compatibility.VB6.FixedLengthString(50)

        'Determine if we can read the data
        nRC = csp2ReadData

        If nRC > 0 Then
            'cs1504 has barcodes!
            nNumOfBarcodes = nRC

            DisplayInBCWindow("Leyendo " & CStr(nRC) & " códigos de barras a las " & TimeOfDay)

            'Check to see that we are in ascii mode...
            If csp2GetASCIIMode = PARAM_ON Then
                DisplayInBCWindow("ASCII Mode ON")
                For i = 0 To (nNumOfBarcodes - 1)
                    nBytesRead = csp2GetPacket(arrbyteBarcode(0), i, 100)

                    If nBytesRead > 0 Then
                        'Display the Barcode type
                        nRC = csp2GetCodeType(arrbyteBarcode(1), bstrTmp.Value, Len(bstrTmp.Value))

                        DisplayInBCWindow(bstrTmp.Value)

                        bstrBarcode = ""

                        ' display the barcode is ascii
                        ' skip the length, type, .... timestamp
                        For j = 2 To (nBytesRead - 5)
                            bstrBarcode = bstrBarcode & Chr(arrbyteBarcode(j))
                        Next j

                        'Display the timestamp
                        nRC = csp2TimeStamp2Str(arrbyteBarcode(nBytesRead - 4), bstrTmp.Value, Len(bstrTmp.Value))

                        DisplayInBCWindow(bstrBarcode)
                    End If
                Next i
            Else
                'Add binary mode packets handling here..
                DisplayInBCWindow("Binary Mode ON")
            End If
        Else
            DisplayInBCWindow("No hay códigos de barras que leer.")
        End If
    End Sub

    Public Sub DisplayInBCWindow(ByRef bstrText As String)
        txtCodes.Text = txtCodes.Text & "" & bstrText & vbCrLf
    End Sub
End Class
